diff --git a/src/backend/optimizer/path/costsize.c b/src/backend/optimizer/path/costsize.c
index c5f6593..1789f0b 100644
--- a/src/backend/optimizer/path/costsize.c
+++ b/src/backend/optimizer/path/costsize.c
@@ -1691,19 +1700,19 @@ cost_recursive_union(Path *runion, Path *nrterm, Path *rterm)
  */
 void
 cost_sort(Path *path, PlannerInfo *root,
-		  List *pathkeys, Cost input_cost, double tuples, int width,
-		  Cost comparison_cost, int sort_mem,
+		  List *pathkeys, Cost *input_cost, double tuples, int width,
+		  Cost *comparison_cost, int sort_mem,
 		  double limit_tuples)
 {
-	Cost		startup_cost = input_cost;
-	Cost		run_cost = 0;
+	Cost		startup_cost = *input_cost;
+	Cost		run_cost = {0};
 	double		input_bytes = relation_byte_size(tuples, width);
 	double		output_bytes;
 	double		output_tuples;
 	long		sort_mem_bytes = sort_mem * 1024L;
 
 	if (!enable_sort)
-		startup_cost += disable_cost;
+		cost_add_member(&startup_cost, disable_cost);
 
 	path->rows = tuples;
 
@@ -1715,7 +1724,7 @@ cost_sort(Path *path, PlannerInfo *root,
 		tuples = 2.0;
 
 	/* Include the default cost-per-comparison */
-	comparison_cost += 2.0 * cpu_operator_cost;
+	cost_add_member_mul(comparison_cost, cpu_operator_cost, 2.0);
 
 	/* Do we have a useful LIMIT? */
 	if (limit_tuples > 0 && limit_tuples < tuples)
@@ -1745,7 +1754,7 @@ cost_sort(Path *path, PlannerInfo *root,
 		 *
 		 * Assume about N log2 N comparisons
 		 */
-		startup_cost += comparison_cost * tuples * LOG2(tuples);
+		cost_add_mul(&startup_cost, comparison_cost, tuples * LOG2(tuples));
 
 		/* Disk costs */
 
@@ -1756,8 +1765,8 @@ cost_sort(Path *path, PlannerInfo *root,
 			log_runs = 1.0;
 		npageaccesses = 2.0 * npages * log_runs;
 		/* Assume 3/4ths of accesses are sequential, 1/4th are not */
-		startup_cost += npageaccesses *
-			(seq_page_cost * 0.75 + random_page_cost * 0.25);
+		cost_add_member_mul(&startup_cost, seq_page_cost, npageaccesses * 0.75);
+		cost_add_member_mul(&startup_cost, random_page_cost, npageaccesses * 0.25);
 	}
 	else if (tuples > 2 * output_tuples || input_bytes > sort_mem_bytes)
 	{
@@ -1767,12 +1776,12 @@ cost_sort(Path *path, PlannerInfo *root,
 		 * factor is a bit higher than for quicksort.  Tweak it so that the
 		 * cost curve is continuous at the crossover point.
 		 */
-		startup_cost += comparison_cost * tuples * LOG2(2.0 * output_tuples);
+		cost_add_mul(&startup_cost, comparison_cost, tuples * LOG2(2.0 * output_tuples));
 	}
 	else
 	{
 		/* We'll use plain quicksort on all the input tuples */
-		startup_cost += comparison_cost * tuples * LOG2(tuples);
+		cost_add_mul(&startup_cost, comparison_cost, tuples * LOG2(tuples));
 	}
 
 	/*
@@ -1783,10 +1792,10 @@ cost_sort(Path *path, PlannerInfo *root,
 	 * here --- the upper LIMIT will pro-rate the run cost so we'd be double
 	 * counting the LIMIT otherwise.
 	 */
-	run_cost += cpu_operator_cost * tuples;
+	cost_add_member_mul(&run_cost, cpu_operator_cost, tuples);
 
 	path->startup_cost = startup_cost;
-	path->total_cost = startup_cost + run_cost;
+	cost_set_sum2(&path->total_cost, &startup_cost, &run_cost);
 }
 
 /*
@@ -1795,7 +1804,7 @@ cost_sort(Path *path, PlannerInfo *root,
  *	  The non-partial paths are assumed to be the first "numpaths" paths
  *	  from the subpaths list, and to be in order of decreasing cost.
  */
-static Cost
+static Cost *
 append_nonpartial_cost(List *subpaths, int numpaths, int parallel_workers)
 {
 	Cost	   *costarr;
@@ -1808,7 +1817,7 @@ append_nonpartial_cost(List *subpaths, int numpaths, int parallel_workers)
 	int			max_index;
 
 	if (numpaths == 0)
-		return 0;
+		return NULL;
 
 	/*
 	 * Array length is number of workers or number of relevant paths,
@@ -1847,12 +1856,12 @@ append_nonpartial_cost(List *subpaths, int numpaths, int parallel_workers)
 		if (path_index++ == numpaths)
 			break;
 
-		costarr[min_index] += subpath->total_cost;
+		cost_add(&costarr[min_index], &subpath->total_cost);
 
 		/* Update the new min cost array index */
 		for (min_index = i = 0; i < arrlen; i++)
 		{
-			if (costarr[i] < costarr[min_index])
+			if (cost_islt(&costarr[i], &costarr[min_index]))
 				min_index = i;
 		}
 	}
@@ -1860,11 +1869,11 @@ append_nonpartial_cost(List *subpaths, int numpaths, int parallel_workers)
 	/* Return the highest cost from the array */
 	for (max_index = i = 0; i < arrlen; i++)
 	{
-		if (costarr[i] > costarr[max_index])
+		if (cost_isgt(&costarr[i], &costarr[max_index]))
 			max_index = i;
 	}
 
-	return costarr[max_index];
+	return costarr+max_index;
 }
 
 /*
@@ -1876,8 +1885,8 @@ cost_append(AppendPath *apath)
 {
 	ListCell   *l;
 
-	apath->path.startup_cost = 0;
-	apath->path.total_cost = 0;
+	cost_zero(&apath->path.startup_cost);
+	cost_zero(&apath->path.total_cost);
 	apath->path.rows = 0;
 
 	if (apath->subpaths == NIL)
@@ -1903,7 +1912,7 @@ cost_append(AppendPath *apath)
 				Path	   *subpath = (Path *) lfirst(l);
 
 				apath->path.rows += subpath->rows;
-				apath->path.total_cost += subpath->total_cost;
+				cost_add(&apath->path.total_cost, &subpath->total_cost);
 			}
 		}
 		else
@@ -1933,6 +1942,7 @@ cost_append(AppendPath *apath)
 
 				if (!pathkeys_contained_in(pathkeys, subpath->pathkeys))
 				{
+					Cost zerocost = {0};
 					/*
 					 * We'll need to insert a Sort node, so include costs for
 					 * that.  We can use the parent's LIMIT if any, since we
@@ -1942,18 +1952,18 @@ cost_append(AppendPath *apath)
 					cost_sort(&sort_path,
 							  NULL, /* doesn't currently need root */
 							  pathkeys,
-							  subpath->total_cost,
+							  &subpath->total_cost,
 							  subpath->rows,
 							  subpath->pathtarget->width,
-							  0.0,
+							  &zerocost,
 							  work_mem,
 							  apath->limit_tuples);
 					subpath = &sort_path;
 				}
 
 				apath->path.rows += subpath->rows;
-				apath->path.startup_cost += subpath->startup_cost;
-				apath->path.total_cost += subpath->total_cost;
+				cost_add(&apath->path.startup_cost, &subpath->startup_cost);
+				cost_add(&apath->path.total_cost, &subpath->total_cost);
 			}
 		}
 	}
@@ -1978,8 +1988,10 @@ cost_append(AppendPath *apath)
 			if (i == 0)
 				apath->path.startup_cost = subpath->startup_cost;
 			else if (i < apath->path.parallel_workers)
-				apath->path.startup_cost = Min(apath->path.startup_cost,
-											   subpath->startup_cost);
+				apath->path.startup_cost = cost_islt(&apath->path.startup_cost,
+											   &subpath->startup_cost) ?
+												apath->path.startup_cost :
+												subpath->startup_cost;
 
 			/*
 			 * Apply parallel divisor to subpaths.  Scale the number of rows
@@ -1997,7 +2009,7 @@ cost_append(AppendPath *apath)
 				subpath_parallel_divisor = get_parallel_divisor(subpath);
 				apath->path.rows += subpath->rows * (subpath_parallel_divisor /
 													 parallel_divisor);
-				apath->path.total_cost += subpath->total_cost;
+				cost_add(&apath->path.total_cost, &subpath->total_cost);
 			}
 
 			apath->path.rows = clamp_row_est(apath->path.rows);
@@ -2006,18 +2018,18 @@ cost_append(AppendPath *apath)
 		}
 
 		/* Add cost for non-partial subpaths. */
-		apath->path.total_cost +=
+		cost_add(&apath->path.total_cost,
 			append_nonpartial_cost(apath->subpaths,
 								   apath->first_partial_path,
-								   apath->path.parallel_workers);
+								   apath->path.parallel_workers));
 	}
 
 	/*
 	 * Although Append does not do any selection or projection, it's not free;
 	 * add a small per-tuple overhead.
 	 */
-	apath->path.total_cost +=
-		cpu_tuple_cost * APPEND_CPU_COST_MULTIPLIER * apath->path.rows;
+	cost_add_member_mul(&apath->path.total_cost,
+		cpu_tuple_cost, APPEND_CPU_COST_MULTIPLIER * apath->path.rows);
 }
 
 /*
@@ -2050,8 +2062,8 @@ cost_merge_append(Path *path, PlannerInfo *root,
 				  Cost input_startup_cost, Cost input_total_cost,
 				  double tuples)
 {
-	Cost		startup_cost = 0;
-	Cost		run_cost = 0;
+	Cost		startup_cost = {0};
+	Cost		run_cost = {0};
 	Cost		comparison_cost;
 	double		N;
 	double		logN;
@@ -2063,22 +2075,22 @@ cost_merge_append(Path *path, PlannerInfo *root,
 	logN = LOG2(N);
 
 	/* Assumed cost per tuple comparison */
-	comparison_cost = 2.0 * cpu_operator_cost;
+	cost_add_member_mul(&comparison_cost, cpu_operator_cost, 2.0);
 
 	/* Heap creation cost */
-	startup_cost += comparison_cost * N * logN;
+	cost_add_mul(&startup_cost, &comparison_cost, N * logN);
 
 	/* Per-tuple heap maintenance cost */
-	run_cost += tuples * comparison_cost * logN;
+	cost_add_mul(&run_cost, &comparison_cost, logN);
 
 	/*
 	 * Although MergeAppend does not do any selection or projection, it's not
 	 * free; add a small per-tuple overhead.
 	 */
-	run_cost += cpu_tuple_cost * APPEND_CPU_COST_MULTIPLIER * tuples;
+	cost_add_member_mul(&run_cost, cpu_tuple_cost, APPEND_CPU_COST_MULTIPLIER * tuples);
 
-	path->startup_cost = startup_cost + input_startup_cost;
-	path->total_cost = startup_cost + run_cost + input_total_cost;
+	cost_set_sum2(&path->startup_cost, &startup_cost, &input_startup_cost);
+	cost_set_sum3(&path->total_cost, &startup_cost, &run_cost, &input_total_cost);
 }
 
 /*
@@ -2099,10 +2111,11 @@ cost_material(Path *path,
 			  double tuples, int width)
 {
 	Cost		startup_cost = input_startup_cost;
-	Cost		run_cost = input_total_cost - input_startup_cost;
+	Cost		run_cost;
 	double		nbytes = relation_byte_size(tuples, width);
 	long		work_mem_bytes = work_mem * 1024L;
 
+	cost_set_diff(&run_cost, &input_total_cost, &input_startup_cost);
 	path->rows = tuples;
 
 	/*
@@ -2117,7 +2130,7 @@ cost_material(Path *path,
 	 * doesn't do qual-checking or projection, so it's got less overhead than
 	 * most plan nodes.
 	 */
-	run_cost += 2 * cpu_operator_cost * tuples;
+	cost_add_member_mul(&run_cost, cpu_operator_cost, 2 * tuples);
 
 	/*
 	 * If we will spill to disk, charge at the rate of seq_page_cost per page.
@@ -2129,11 +2142,11 @@ cost_material(Path *path,
 	{
 		double		npages = ceil(nbytes / BLCKSZ);
 
-		run_cost += seq_page_cost * npages;
+		cost_add_member_mul(&run_cost, seq_page_cost, npages);
 	}
 
 	path->startup_cost = startup_cost;
-	path->total_cost = startup_cost + run_cost;
+	cost_set_sum2(&path->total_cost, &startup_cost, &run_cost);
 }
 
 /*
@@ -2152,7 +2165,7 @@ cost_agg(Path *path, PlannerInfo *root,
 		 AggStrategy aggstrategy, const AggClauseCosts *aggcosts,
 		 int numGroupCols, double numGroups,
 		 List *quals,
-		 Cost input_startup_cost, Cost input_total_cost,
+		 Cost *input_startup_cost, Cost *input_total_cost,
 		 double input_tuples)
 {
 	double		output_tuples;
@@ -2192,47 +2205,48 @@ cost_agg(Path *path, PlannerInfo *root,
 	 */
 	if (aggstrategy == AGG_PLAIN)
 	{
-		startup_cost = input_total_cost;
-		startup_cost += aggcosts->transCost.startup;
-		startup_cost += aggcosts->transCost.per_tuple * input_tuples;
-		startup_cost += aggcosts->finalCost.startup;
-		startup_cost += aggcosts->finalCost.per_tuple;
+		startup_cost = *input_total_cost;
+		cost_add(&startup_cost, &aggcosts->transCost.startup);
+		cost_add_mul(&startup_cost, &aggcosts->transCost.per_tuple, input_tuples);
+		cost_add(&startup_cost, &aggcosts->finalCost.startup);
+		cost_add(&startup_cost, &aggcosts->finalCost.per_tuple);
 		/* we aren't grouping */
-		total_cost = startup_cost + cpu_tuple_cost;
+		total_cost = startup_cost;
+		cost_add_member(&total_cost, cpu_tuple_cost);
 		output_tuples = 1;
 	}
 	else if (aggstrategy == AGG_SORTED || aggstrategy == AGG_MIXED)
 	{
 		/* Here we are able to deliver output on-the-fly */
-		startup_cost = input_startup_cost;
-		total_cost = input_total_cost;
+		startup_cost = *input_startup_cost;
+		total_cost = *input_total_cost;
 		if (aggstrategy == AGG_MIXED && !enable_hashagg)
 		{
-			startup_cost += disable_cost;
-			total_cost += disable_cost;
+			cost_add_member(&startup_cost, disable_cost);
+			cost_add_member(&total_cost, disable_cost);
 		}
 		/* calcs phrased this way to match HASHED case, see note above */
-		total_cost += aggcosts->transCost.startup;
-		total_cost += aggcosts->transCost.per_tuple * input_tuples;
-		total_cost += (cpu_operator_cost * numGroupCols) * input_tuples;
-		total_cost += aggcosts->finalCost.startup;
-		total_cost += aggcosts->finalCost.per_tuple * numGroups;
-		total_cost += cpu_tuple_cost * numGroups;
+		cost_add(&total_cost, &aggcosts->transCost.startup);
+		cost_add_mul(&total_cost, &aggcosts->transCost.per_tuple, input_tuples);
+		cost_add_member_mul(&total_cost, cpu_operator_cost, numGroupCols * input_tuples);
+		cost_add(&total_cost, &aggcosts->finalCost.startup);
+		cost_add_mul(&total_cost, &aggcosts->finalCost.per_tuple, numGroups);
+		cost_add_member_mul(&total_cost, cpu_tuple_cost, numGroups);
 		output_tuples = numGroups;
 	}
 	else
 	{
 		/* must be AGG_HASHED */
-		startup_cost = input_total_cost;
+		startup_cost = *input_total_cost;
 		if (!enable_hashagg)
-			startup_cost += disable_cost;
-		startup_cost += aggcosts->transCost.startup;
-		startup_cost += aggcosts->transCost.per_tuple * input_tuples;
-		startup_cost += (cpu_operator_cost * numGroupCols) * input_tuples;
-		startup_cost += aggcosts->finalCost.startup;
+			cost_add_member(&startup_cost, disable_cost);
+		cost_add(&startup_cost, &aggcosts->transCost.startup);
+		cost_add_mul(&startup_cost, &aggcosts->transCost.per_tuple, input_tuples);
+		cost_add_member_mul(&startup_cost, cpu_operator_cost, numGroupCols * input_tuples);
+		cost_add(&startup_cost, &aggcosts->finalCost.startup);
 		total_cost = startup_cost;
-		total_cost += aggcosts->finalCost.per_tuple * numGroups;
-		total_cost += cpu_tuple_cost * numGroups;
+		cost_add_mul(&total_cost, &aggcosts->finalCost.per_tuple, numGroups);
+		cost_add_member_mul(&total_cost, cpu_tuple_cost, numGroups);
 		output_tuples = numGroups;
 	}
 
@@ -2245,8 +2259,9 @@ cost_agg(Path *path, PlannerInfo *root,
 		QualCost	qual_cost;
 
 		cost_qual_eval(&qual_cost, quals, root);
-		startup_cost += qual_cost.startup;
-		total_cost += qual_cost.startup + output_tuples * qual_cost.per_tuple;
+		cost_add(&startup_cost, &qual_cost.startup);
+		cost_add(&total_cost, &qual_cost.startup);
+		cost_add_mul(&total_cost, &qual_cost.per_tuple, output_tuples);
 
 		output_tuples = clamp_row_est(output_tuples *
 									  clauselist_selectivity(root,
@@ -2296,26 +2311,27 @@ cost_windowagg(Path *path, PlannerInfo *root,
 		Cost		wfunccost;
 		QualCost	argcosts;
 
-		argcosts.startup = argcosts.per_tuple = 0;
+		cost_zero(&argcosts.startup);
+		cost_zero(&argcosts.per_tuple);
 		add_function_cost(root, wfunc->winfnoid, (Node *) wfunc,
 						  &argcosts);
-		startup_cost += argcosts.startup;
+		cost_add(&startup_cost, &argcosts.startup);
 		wfunccost = argcosts.per_tuple;
 
 		/* also add the input expressions' cost to per-input-row costs */
 		cost_qual_eval_node(&argcosts, (Node *) wfunc->args, root);
-		startup_cost += argcosts.startup;
-		wfunccost += argcosts.per_tuple;
+		cost_add(&startup_cost, &argcosts.startup);
+		cost_add(&wfunccost, &argcosts.per_tuple);
 
 		/*
 		 * Add the filter's cost to per-input-row costs.  XXX We should reduce
 		 * input expression costs according to filter selectivity.
 		 */
 		cost_qual_eval_node(&argcosts, (Node *) wfunc->aggfilter, root);
-		startup_cost += argcosts.startup;
-		wfunccost += argcosts.per_tuple;
+		cost_add(&startup_cost, &argcosts.startup);
+		cost_add(&wfunccost, &argcosts.per_tuple);
 
-		total_cost += wfunccost * input_tuples;
+		cost_add_mul(&total_cost, &wfunccost, input_tuples);
 	}
 
 	/*
@@ -2326,8 +2342,8 @@ cost_windowagg(Path *path, PlannerInfo *root,
 	 * XXX this neglects costs of spooling the data to disk when it overflows
 	 * work_mem.  Sooner or later that should get accounted for.
 	 */
-	total_cost += cpu_operator_cost * (numPartCols + numOrderCols) * input_tuples;
-	total_cost += cpu_tuple_cost * input_tuples;
+	cost_add_member_mul(&total_cost, cpu_operator_cost, (numPartCols + numOrderCols) * input_tuples);
+	cost_add_member_mul(&total_cost, cpu_tuple_cost, input_tuples);
 
 	path->rows = input_tuples;
 	path->startup_cost = startup_cost;
@@ -2361,7 +2377,7 @@ cost_group(Path *path, PlannerInfo *root,
 	 * Charge one cpu_operator_cost per comparison per input tuple. We assume
 	 * all columns get compared at most of the tuples.
 	 */
-	total_cost += cpu_operator_cost * input_tuples * numGroupCols;
+	cost_add_member_mul(&total_cost, cpu_operator_cost, input_tuples * numGroupCols);
 
 	/*
 	 * If there are quals (HAVING quals), account for their cost and
@@ -2372,8 +2388,9 @@ cost_group(Path *path, PlannerInfo *root,
 		QualCost	qual_cost;
 
 		cost_qual_eval(&qual_cost, quals, root);
-		startup_cost += qual_cost.startup;
-		total_cost += qual_cost.startup + output_tuples * qual_cost.per_tuple;
+		cost_add(&startup_cost, &qual_cost.startup);;
+		cost_add(&total_cost, &qual_cost.startup);
+		cost_add_mul(&total_cost, &qual_cost.per_tuple, output_tuples);
 
 		output_tuples = clamp_row_est(output_tuples *
 									  clauselist_selectivity(root,
@@ -2418,8 +2435,8 @@ initial_cost_nestloop(PlannerInfo *root, JoinCostWorkspace *workspace,
 					  Path *outer_path, Path *inner_path,
 					  JoinPathExtraData *extra)
 {
-	Cost		startup_cost = 0;
-	Cost		run_cost = 0;
+	Cost		startup_cost = {0};
+	Cost		run_cost = {0};
 	double		outer_path_rows = outer_path->rows;
 	Cost		inner_rescan_start_cost;
 	Cost		inner_rescan_total_cost;
@@ -2439,13 +2456,14 @@ initial_cost_nestloop(PlannerInfo *root, JoinCostWorkspace *workspace,
 	 * their sum.  We'll also pay the inner path's rescan startup cost
 	 * multiple times.
 	 */
-	startup_cost += outer_path->startup_cost + inner_path->startup_cost;
-	run_cost += outer_path->total_cost - outer_path->startup_cost;
+	cost_add2(&startup_cost, &outer_path->startup_cost, &inner_path->startup_cost);
+	cost_add(&run_cost, &outer_path->total_cost);
+	cost_sub(&run_cost, &outer_path->startup_cost);
 	if (outer_path_rows > 1)
-		run_cost += (outer_path_rows - 1) * inner_rescan_start_cost;
+		cost_add_mul(&run_cost, &inner_rescan_start_cost, outer_path_rows - 1);
 
-	inner_run_cost = inner_path->total_cost - inner_path->startup_cost;
-	inner_rescan_run_cost = inner_rescan_total_cost - inner_rescan_start_cost;
+	cost_set_diff(&inner_run_cost, &inner_path->total_cost, &inner_path->startup_cost);
+	cost_set_diff(&inner_rescan_run_cost, &inner_rescan_total_cost, &inner_rescan_start_cost);
 
 	if (jointype == JOIN_SEMI || jointype == JOIN_ANTI ||
 		extra->inner_unique)
@@ -2465,16 +2483,16 @@ initial_cost_nestloop(PlannerInfo *root, JoinCostWorkspace *workspace,
 	else
 	{
 		/* Normal case; we'll scan whole input rel for each outer row */
-		run_cost += inner_run_cost;
+		cost_add(&run_cost, &inner_run_cost);
 		if (outer_path_rows > 1)
-			run_cost += (outer_path_rows - 1) * inner_rescan_run_cost;
+			cost_add_mul(&run_cost, &inner_rescan_run_cost, outer_path_rows - 1);
 	}
 
 	/* CPU costs left for later */
 
 	/* Public result fields */
 	workspace->startup_cost = startup_cost;
-	workspace->total_cost = startup_cost + run_cost;
+	cost_set_sum2(&workspace->total_cost, &startup_cost, &run_cost);
 	/* Save private data for final_cost_nestloop */
 	workspace->run_cost = run_cost;
 }
@@ -2529,7 +2547,7 @@ final_cost_nestloop(PlannerInfo *root, NestPath *path,
 	 * disabled, which doesn't seem like the way to bet.
 	 */
 	if (!enable_nestloop)
-		startup_cost += disable_cost;
+		cost_add_member(&startup_cost, disable_cost);
 
 	/* cost of inner-relation source data (we already dealt with outer rel) */
 
@@ -2590,9 +2608,9 @@ final_cost_nestloop(PlannerInfo *root, NestPath *path,
 			 * case, use inner_run_cost for the first matched tuple and
 			 * inner_rescan_run_cost for additional ones.
 			 */
-			run_cost += inner_run_cost * inner_scan_frac;
+			cost_add_mul(&run_cost, &inner_run_cost, inner_scan_frac);
 			if (outer_matched_rows > 1)
-				run_cost += (outer_matched_rows - 1) * inner_rescan_run_cost * inner_scan_frac;
+				cost_add_mul(&run_cost, &inner_rescan_run_cost, (outer_matched_rows - 1) * inner_scan_frac);
 
 			/*
 			 * Add the cost of inner-scan executions for unmatched outer rows.
@@ -2600,8 +2618,7 @@ final_cost_nestloop(PlannerInfo *root, NestPath *path,
 			 * of a nonempty scan.  We consider that these are all rescans,
 			 * since we used inner_run_cost once already.
 			 */
-			run_cost += outer_unmatched_rows *
-				inner_rescan_run_cost / inner_path_rows;
+			cost_add_mul(&run_cost, &inner_rescan_run_cost, outer_unmatched_rows / inner_path_rows);
 
 			/*
 			 * We won't be evaluating any quals at all for unmatched rows, so
@@ -2627,7 +2644,7 @@ final_cost_nestloop(PlannerInfo *root, NestPath *path,
 			ntuples += outer_unmatched_rows * inner_path_rows;
 
 			/* Now add the forced full scan, and decrement appropriate count */
-			run_cost += inner_run_cost;
+			cost_add(&run_cost, &inner_run_cost);
 			if (outer_unmatched_rows >= 1)
 				outer_unmatched_rows -= 1;
 			else
@@ -2635,11 +2652,11 @@ final_cost_nestloop(PlannerInfo *root, NestPath *path,
 
 			/* Add inner run cost for additional outer tuples having matches */
 			if (outer_matched_rows > 0)
-				run_cost += outer_matched_rows * inner_rescan_run_cost * inner_scan_frac;
+				cost_add_mul(&run_cost, &inner_rescan_run_cost, outer_matched_rows * inner_scan_frac);
 
 			/* Add inner run cost for additional unmatched outer tuples */
 			if (outer_unmatched_rows > 0)
-				run_cost += outer_unmatched_rows * inner_rescan_run_cost;
+				cost_add_mul(&run_cost, &inner_rescan_run_cost, outer_unmatched_rows);
 		}
 	}
 	else
@@ -2652,16 +2669,17 @@ final_cost_nestloop(PlannerInfo *root, NestPath *path,
 
 	/* CPU costs */
 	cost_qual_eval(&restrict_qual_cost, path->joinrestrictinfo, root);
-	startup_cost += restrict_qual_cost.startup;
-	cpu_per_tuple = cpu_tuple_cost + restrict_qual_cost.per_tuple;
-	run_cost += cpu_per_tuple * ntuples;
+	cost_add(&startup_cost, &restrict_qual_cost.startup);
+	cpu_per_tuple = restrict_qual_cost.per_tuple;
+	cost_add_member(&cpu_per_tuple, cpu_tuple_cost);
+	cost_add_mul(&run_cost, &cpu_per_tuple, ntuples);
 
 	/* tlist eval costs are paid per output row, not per tuple scanned */
-	startup_cost += path->path.pathtarget->cost.startup;
-	run_cost += path->path.pathtarget->cost.per_tuple * path->path.rows;
+	cost_add(&startup_cost, &path->path.pathtarget->cost.startup);
+	cost_add_mul(&run_cost, &path->path.pathtarget->cost.per_tuple, path->path.rows);
 
 	path->path.startup_cost = startup_cost;
-	path->path.total_cost = startup_cost + run_cost;
+	cost_set_sum2(&path->path.total_cost, &startup_cost, &run_cost);
 }
 
 /*
@@ -2702,8 +2720,9 @@ initial_cost_mergejoin(PlannerInfo *root, JoinCostWorkspace *workspace,
 					   List *outersortkeys, List *innersortkeys,
 					   JoinPathExtraData *extra)
 {
-	Cost		startup_cost = 0;
-	Cost		run_cost = 0;
+	Cost		startup_cost = {0};
+	Cost		run_cost = {0};
+	Cost		zerocost = {0};
 	double		outer_path_rows = outer_path->rows;
 	double		inner_path_rows = inner_path->rows;
 	Cost		inner_run_cost;
@@ -2825,28 +2844,28 @@ initial_cost_mergejoin(PlannerInfo *root, JoinCostWorkspace *workspace,
 
 	if (outersortkeys)			/* do we need to sort outer? */
 	{
+		Cost tmp;
 		cost_sort(&sort_path,
 				  root,
 				  outersortkeys,
-				  outer_path->total_cost,
+				  &outer_path->total_cost,
 				  outer_path_rows,
 				  outer_path->pathtarget->width,
-				  0.0,
+				  &zerocost,
 				  work_mem,
 				  -1.0);
-		startup_cost += sort_path.startup_cost;
-		startup_cost += (sort_path.total_cost - sort_path.startup_cost)
-			* outerstartsel;
-		run_cost += (sort_path.total_cost - sort_path.startup_cost)
-			* (outerendsel - outerstartsel);
+		cost_add(&startup_cost, &sort_path.startup_cost);
+		cost_set_diff(&tmp, &sort_path.total_cost, &sort_path.startup_cost);
+		cost_add_mul(&startup_cost, &tmp, outerstartsel);
+		cost_add_mul(&run_cost, &tmp, outerendsel - outerstartsel);
 	}
 	else
 	{
-		startup_cost += outer_path->startup_cost;
-		startup_cost += (outer_path->total_cost - outer_path->startup_cost)
-			* outerstartsel;
-		run_cost += (outer_path->total_cost - outer_path->startup_cost)
-			* (outerendsel - outerstartsel);
+		Cost tmp;
+		cost_add(&startup_cost, &outer_path->startup_cost);
+		cost_set_diff(&tmp, &outer_path->total_cost, &outer_path->startup_cost);
+		cost_add_mul(&startup_cost, &tmp, outerstartsel);
+		cost_add_mul(&run_cost, &tmp, outerendsel - outerstartsel);
 	}
 
 	if (innersortkeys)			/* do we need to sort inner? */
@@ -2854,25 +2873,23 @@ initial_cost_mergejoin(PlannerInfo *root, JoinCostWorkspace *workspace,
 		cost_sort(&sort_path,
 				  root,
 				  innersortkeys,
-				  inner_path->total_cost,
+				  &inner_path->total_cost,
 				  inner_path_rows,
 				  inner_path->pathtarget->width,
-				  0.0,
+				  &zerocost,
 				  work_mem,
 				  -1.0);
-		startup_cost += sort_path.startup_cost;
-		startup_cost += (sort_path.total_cost - sort_path.startup_cost)
-			* innerstartsel;
-		inner_run_cost = (sort_path.total_cost - sort_path.startup_cost)
-			* (innerendsel - innerstartsel);
+		cost_add(&startup_cost, &sort_path.startup_cost);
+		cost_set_diff(&inner_run_cost, &sort_path.total_cost, &sort_path.startup_cost);
+		cost_add_mul(&startup_cost, &inner_run_cost, innerstartsel);
+		cost_mul_scalar(&inner_run_cost, innerendsel - innerstartsel);
 	}
 	else
 	{
-		startup_cost += inner_path->startup_cost;
-		startup_cost += (inner_path->total_cost - inner_path->startup_cost)
-			* innerstartsel;
-		inner_run_cost = (inner_path->total_cost - inner_path->startup_cost)
-			* (innerendsel - innerstartsel);
+		cost_add(&startup_cost, &inner_path->startup_cost);
+		cost_set_diff(&inner_run_cost, &inner_path->total_cost, &inner_path->startup_cost);
+		cost_add_mul(&startup_cost, &inner_run_cost, innerstartsel);
+		cost_mul_scalar(&inner_run_cost, innerendsel - innerstartsel);
 	}
 
 	/*
@@ -2887,7 +2904,7 @@ initial_cost_mergejoin(PlannerInfo *root, JoinCostWorkspace *workspace,
 
 	/* Public result fields */
 	workspace->startup_cost = startup_cost;
-	workspace->total_cost = startup_cost + run_cost + inner_run_cost;
+	cost_set_sum3(&workspace->total_cost, &startup_cost, &run_cost, &inner_run_cost);
 	/* Save private data for final_cost_mergejoin */
 	workspace->run_cost = run_cost;
 	workspace->inner_run_cost = inner_run_cost;
@@ -2975,7 +2992,7 @@ final_cost_mergejoin(PlannerInfo *root, MergePath *path,
 	 * disabled, which doesn't seem like the way to bet.
 	 */
 	if (!enable_mergejoin)
-		startup_cost += disable_cost;
+		cost_add_member(&startup_cost, disable_cost);
 
 	/*
 	 * Compute cost of the mergequals and qpquals (other restriction clauses)
@@ -2983,8 +3000,8 @@ final_cost_mergejoin(PlannerInfo *root, MergePath *path,
 	 */
 	cost_qual_eval(&merge_qual_cost, mergeclauses, root);
 	cost_qual_eval(&qp_qual_cost, path->jpath.joinrestrictinfo, root);
-	qp_qual_cost.startup -= merge_qual_cost.startup;
-	qp_qual_cost.per_tuple -= merge_qual_cost.per_tuple;
+	cost_sub(&qp_qual_cost.startup, &merge_qual_cost.startup);
+	cost_sub(&qp_qual_cost.per_tuple, &merge_qual_cost.per_tuple);
 
 	/*
 	 * With a SEMI or ANTI join, or if the innerrel is known unique, the
@@ -3059,7 +3076,8 @@ final_cost_mergejoin(PlannerInfo *root, MergePath *path,
 	 * a more refined model.  So we just need to inflate the inner run cost by
 	 * rescanratio.
 	 */
-	bare_inner_cost = inner_run_cost * rescanratio;
+	bare_inner_cost = inner_run_cost;
+	cost_mul_scalar(&bare_inner_cost, rescanratio);
 
 	/*
 	 * When we interpose a Material node the re-fetch cost is assumed to be
@@ -3074,8 +3092,8 @@ final_cost_mergejoin(PlannerInfo *root, MergePath *path,
 	 * Note: keep this estimate in sync with create_mergejoin_plan's labeling
 	 * of the generated Material node.
 	 */
-	mat_inner_cost = inner_run_cost +
-		cpu_operator_cost * inner_rows * rescanratio;
+	mat_inner_cost = inner_run_cost;
+	cost_add_member_mul(&mat_inner_cost, cpu_operator_cost, inner_rows * rescanratio);
 
 	/*
 	 * If we don't need mark/restore at all, we don't need materialization.
@@ -3087,7 +3105,7 @@ final_cost_mergejoin(PlannerInfo *root, MergePath *path,
 	 * Prefer materializing if it looks cheaper, unless the user has asked to
 	 * suppress materialization.
 	 */
-	else if (enable_material && mat_inner_cost < bare_inner_cost)
+	else if (enable_material && cost_asscalar(&mat_inner_cost) < cost_asscalar(&bare_inner_cost))
 		path->materialize_inner = true;
 
 	/*
@@ -3131,9 +3149,9 @@ final_cost_mergejoin(PlannerInfo *root, MergePath *path,
 
 	/* Charge the right incremental cost for the chosen case */
 	if (path->materialize_inner)
-		run_cost += mat_inner_cost;
+		cost_add(&run_cost, &mat_inner_cost);
 	else
-		run_cost += bare_inner_cost;
+		cost_add(&run_cost, &bare_inner_cost);
 
 	/* CPU costs */
 
@@ -3142,12 +3160,12 @@ final_cost_mergejoin(PlannerInfo *root, MergePath *path,
 	 * rows plus number of inner rows plus number of rescanned tuples (can we
 	 * refine this?).  At each one, we need to evaluate the mergejoin quals.
 	 */
-	startup_cost += merge_qual_cost.startup;
-	startup_cost += merge_qual_cost.per_tuple *
-		(outer_skip_rows + inner_skip_rows * rescanratio);
-	run_cost += merge_qual_cost.per_tuple *
+	cost_add(&startup_cost, &merge_qual_cost.startup);
+	cost_add_mul(&startup_cost, &merge_qual_cost.per_tuple,
+		outer_skip_rows + inner_skip_rows * rescanratio);
+	cost_add_mul(&run_cost, &merge_qual_cost.per_tuple,
 		((outer_rows - outer_skip_rows) +
-		 (inner_rows - inner_skip_rows) * rescanratio);
+		 (inner_rows - inner_skip_rows) * rescanratio));
 
 	/*
 	 * For each tuple that gets through the mergejoin proper, we charge
@@ -3158,16 +3176,16 @@ final_cost_mergejoin(PlannerInfo *root, MergePath *path,
 	 * Note: we could adjust for SEMI/ANTI joins skipping some qual
 	 * evaluations here, but it's probably not worth the trouble.
 	 */
-	startup_cost += qp_qual_cost.startup;
-	cpu_per_tuple = cpu_tuple_cost + qp_qual_cost.per_tuple;
-	run_cost += cpu_per_tuple * mergejointuples;
+	cost_add(&startup_cost, &qp_qual_cost.startup);
+	cost_set_member_add(&cpu_per_tuple, cpu_tuple_cost, &qp_qual_cost.per_tuple);
+	cost_add_mul(&run_cost, &cpu_per_tuple, mergejointuples);
 
 	/* tlist eval costs are paid per output row, not per tuple scanned */
-	startup_cost += path->jpath.path.pathtarget->cost.startup;
-	run_cost += path->jpath.path.pathtarget->cost.per_tuple * path->jpath.path.rows;
+	cost_add(&startup_cost, &path->jpath.path.pathtarget->cost.startup);
+	cost_add_mul(&run_cost, &path->jpath.path.pathtarget->cost.per_tuple, path->jpath.path.rows);
 
 	path->jpath.path.startup_cost = startup_cost;
-	path->jpath.path.total_cost = startup_cost + run_cost;
+	cost_set_sum2(&path->jpath.path.total_cost, &startup_cost, &run_cost);
 }
 
 /*
@@ -3260,8 +3278,8 @@ initial_cost_hashjoin(PlannerInfo *root, JoinCostWorkspace *workspace,
 					  JoinPathExtraData *extra,
 					  bool parallel_hash)
 {
-	Cost		startup_cost = 0;
-	Cost		run_cost = 0;
+	Cost		startup_cost = {0};
+	Cost		run_cost = {0};
 	double		outer_path_rows = outer_path->rows;
 	double		inner_path_rows = inner_path->rows;
 	double		inner_path_rows_total = inner_path_rows;
@@ -3272,9 +3290,10 @@ initial_cost_hashjoin(PlannerInfo *root, JoinCostWorkspace *workspace,
 	size_t		space_allowed;	/* unused */
 
 	/* cost of source data */
-	startup_cost += outer_path->startup_cost;
-	run_cost += outer_path->total_cost - outer_path->startup_cost;
-	startup_cost += inner_path->total_cost;
+	cost_add(&startup_cost, &outer_path->startup_cost);
+	cost_add(&run_cost, &outer_path->total_cost);
+	cost_sub(&run_cost, &outer_path->startup_cost);
+	cost_add(&startup_cost, &inner_path->total_cost);
 
 	/*
 	 * Cost of computing hash function: must do it once per input tuple. We
